#cs ==================================================================================================================================================
	
	AutoIt Version: 3.2.3.2 (beta)
	Author:         alexmadman
	
	Script Functions:
	coolprogressbarcreate($top , $left , $width , $height , $vert , $color ,$border=0,$bordercolor=0xffffff ,$randomcolor=0)-creates a coolprogress bar in a previuosly created
	GUI, returns a special id number used to identefy multiple progress bars
	coolprogressbarpercent($nums , $percent: sets the percent of a previously created coolprogressbar (with the id $nums)to $percent
	Obs: for nou it cannot set it to less than it allready is
	coolprogressbarrefresh($nums,$percent) , refreshes a previously created coolprogressbar(with the id number $nums) to a certain percent
	this function is explicitly made for coolprogressbarchange
	coolprogressbarchange($nums,$border,$bordercolor=0,$color=0,$randomcolor=0)
	this function changes the settings of a previously created  coolprogressbar(with the id $nums)
	"" is default
	coolprogressbardelete($nums):  :) deletes a coolprogressbar
	Template AutoIt script.
	
#ce ==================================================================================================================================================

; Script Start - Add your code below here
Global $num
Global $pg_border_n[1000]
Global $pg_border_c[1000]
Global $pg_border_h[1000]
Global $pg_color[1000]
Global $pg_random[1000]
Global $pg_label[1000][10000]
Global $pg_state[1000]
Global $pg_count[1000]
Global $pg_coord_t[1000]
Global $pg_coord_l[1000]
Global $pg_coord_w[1000]
Global $pg_coord_h[100000]



#include <GuiConstants.au3>
;=====================================================================================================================================================
Func coolprogressbarcreate($top, $left, $width, $height, $vert, $color, $border = 0, $bordercolor = 0xffffff, $randomcolor = 0)
	If Not $num Then
		$num = 1
	Else
		$num += 1
	EndIf
	$pg_border_n[$num] = $border
	$pg_border_c[$num] = $bordercolor
	$pg_color[$num] = $color
	$pg_random[$num] = $randomcolor
	$pg_state[$num] = 0
	$pg_coord_t[$num] = $top
	$pg_coord_l[$num] = $left
	$pg_coord_w[$num] = $width
	$pg_coord_h[$num] = $height
	
	$pg_border_h[$num] = GUICtrlCreateLabel("", $left - $border, $top - $border, $width + 2 * $border, $height + 2 * $border)

	Select
		Case $vert = 0
			$pg_count[$num] = $width
			For $i = 1 To $width
				$pg_label[$num][$i] = GUICtrlCreateLabel("", $left + $i - 1, $top, 1, $height)
			Next
		Case $vert = 1
			$pg_count[$num] = $height
			For $i = $height To 1 Step - 1
				$pg_label[$num][$height - $i] = GUICtrlCreateLabel("", $left, $top + $i, $width, 1)
			Next
	EndSelect
	GUICtrlSetBkColor($pg_border_h[$num], $bordercolor)
	Return $num
EndFunc   ;==>coolprogressbarcreate
;========================================================================================================================================================
Func coolprogressbarpercent($nums, $percent)
	For $i = $pg_count[$nums] / 100 * $pg_state[$nums] To $pg_count[$nums] / 100 * $percent
		If Not $pg_random[$nums] Then
			GUICtrlSetBkColor($pg_label[$nums][$i], $pg_color[$nums])
		Else
			GUICtrlSetBkColor($pg_label[$nums][$i], Random(Dec(0x000000), Dec(0xffffff)))
		EndIf
	Next
	$pg_state[$nums] = $percent
EndFunc   ;==>coolprogressbarpercent
;========================================================================================================================================================
Func coolprogressbarrefresh($nums, $percent)
	For $i = 1 To $pg_count[$nums] / 100 * $percent
		If Not $pg_random[$nums] Then
			GUICtrlSetBkColor($pg_label[$nums][$i], $pg_color[$nums])
		Else
			GUICtrlSetBkColor($pg_label[$nums][$i], Random(Dec(0x000000), Dec(0xffffff)))
		EndIf
	Next
EndFunc   ;==>coolprogressbarrefresh
;=========================================================================================================================================================

Func coolprogressbarchange($nums, $border, $bordercolor = 0, $color = 0, $randomcolor = 0)
	If $border Then
		$pg_border_n[$num] = $border
		GUICtrlSetPos($pg_border_h[$nums], $pg_coord_l[$nums] - $border, $pg_coord_t[$nums] - $border, $pg_coord_w[$nums] + 2 * $border, $pg_coord_h[$nums] + 2 * $border)
	EndIf
	If $bordercolor Then
		$pg_border_c[$nums] = $bordercolor
		GUICtrlSetBkColor($pg_border_h[$nums], $bordercolor)
	EndIf
	If $randomcolor Then
		$pg_random[$nums] = 1
		coolprogressbarrefresh($nums, $pg_state[$nums])
		Return
	EndIf
	If Not $randomcolor Then
		$pg_random[$nums] = 0
		If $color = 1 Then
			$pg_color[$nums] = $color
		EndIf
		coolprogressbarrefresh($nums, $pg_state[$nums])
	EndIf
EndFunc   ;==>coolprogressbarchange
;========================================================================================================================================================
Func coolprogressbardelete($nums)
	For $i = 0 To $pg_count[$nums]
		GUICtrlDelete($pg_label[$nums][$i])
	Next
	GUICtrlDelete($pg_border_h[$nums])
EndFunc   ;==>coolprogressbardelete
